# © 2020 Le Filament (<http://www.le-filament.com>)
# License AGPL-3.0 or later (http://www.gnu.org/licenses/agpl.html).

from odoo import api, models
from odoo.exceptions import UserError


class LeFilamentAlfresco(models.AbstractModel):
    """ Appelle l'API alfresco et implémente les fonctions suivantes :

    """
    _inherit = 'lefilament.alfresco'

    def publipostage_documents(self, url, path, template_doc, backend, keys=None, versionable=None):
        if template_doc.type_temp == "facture":
            template_name = "lettre_facture_" + self.partner_id.name + "_" + str(self.date_invoice) + ".docx"
            # get NodeRef from folder linked
            cmis_obj_nodeRef = backend.get_folder_by_path(path).getProperties()['alfcmis:nodeRef']

            options = {
                "destinationNodeRef": cmis_obj_nodeRef,
                "versionable": versionable,
            }

            return self.alfresco_publipostage_documents(
                url=url,
                filename=template_name,
                templateNodeRef=template_doc.noderef_document,
                convertToPDF=False,
                keys=keys,
                options=options,
                backend=backend)
        else:
            return super(LeFilamentAlfresco, self).publipostage_documents(url, path, template_doc, backend, keys, versionable)

